
public class City implements Comparable<City> {
	
	private String name;
	private LinkedList<City> destinations;
	private boolean visited;
	
	public City(String name) {
		this.name = name;
		this.destinations = new LinkedList<City>();
	}

	public boolean isVisited() {
		return this.visited;
	}

	public void setVisited(boolean visited) {
		this.visited = visited;
	}

	public String getName() {
		return name;
	}
	
	public void addDestination(City destination) {
		this.destinations.add(destination);
	}
	
	public City[] getDestinations() {
		City[] destinations = new City[this.destinations.size()];
		
		if (this.destinations.isEmpty()) {
			return null;
		} else {
			for ( int i = 0 ; i < this.destinations.size() ; i++ ) {
				destinations[i] = this.destinations.get(i);
			}
		
			return destinations;
		}
	}

	public City[] getUnvisitedDestinations() {
		int countUnvisitedDestinations = 0;
		
		// count the number of unvisited destinations
		for ( int i = 0 ; i < this.destinations.size() ; i++ ) {
			if (!this.destinations.get(i).isVisited()) {
				countUnvisitedDestinations++;
			}
		}
		
		if (countUnvisitedDestinations == 0) {
			return null;
		} else {
			// create an array with the correct number of unvisited destinations
			City[] unvisited = new City[countUnvisitedDestinations];
			int index = 0;
			
			// add all the unvisited destinations to the array
			for ( int i = 0 ; i < this.destinations.size() ; i++ ) {
				if (!this.destinations.get(i).isVisited()) {
					unvisited[index++] = this.destinations.get(i);
				}
			}
			
			return unvisited;
		}
	}
	
	
	@Override
	public int compareTo(City city) {
		return this.name.compareTo(city.getName());
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (obj instanceof City) {
			City city = (City) obj;
			if (this.name.equals(city.getName())) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	
	
	

}
