import java.util.Iterator;

public class Driver {

	private static City newYork, boston, portland, dc, miami, chicago, denver, dallas, sanFransisco, losAngeles;
	private static LinkedStack<City> stack;
	
	public static void initializeCities() {
		newYork = new City("New York");
		boston = new City("Boston");
		portland = new City("Portland");
		dc = new City("DC");
		miami = new City("Miami");
		chicago = new City("Chicago");
		denver = new City("Denver");
		dallas = new City("Dallas");
		sanFransisco = new City("San Fransisco");
		losAngeles = new City("Los Angeles");

		newYork.addDestination(boston);
		newYork.addDestination(dc);
		boston.addDestination(portland);
		boston.addDestination(dc);
		boston.addDestination(chicago);
		portland.addDestination(chicago);
		dc.addDestination(miami);
		dc.addDestination(dallas);
		dallas.addDestination(losAngeles);
		dallas.addDestination(denver);
		denver.addDestination(sanFransisco);
		chicago.addDestination(denver);
		sanFransisco.addDestination(losAngeles);
		losAngeles.addDestination(newYork);
	}
	
	public static void showStack() {
		Iterator<City> iterator = stack.iterator();
		
		System.out.println("----------------");
		System.out.println("Stack = ");
		while (iterator.hasNext()) {
			City city = iterator.next();
			System.out.println(city.getName());
		}
		System.out.println("----------------");
	}
	
	
	public static void main(String[] args) {
		initializeCities();
		stack = new LinkedStack<City>();
		
		City source = newYork;
		source.setVisited(true);

		City destination = sanFransisco;
		
		stack.push(source);
		showStack();
		
		while (!stack.isEmpty() && !stack.peek().equals(destination)) {
			City topOfStack = stack.peek();
			City[] cities = topOfStack.getUnvisitedDestinations();
			
			if (cities != null) {
				for ( int i = 0 ; i < cities.length ; i++ ) {
					System.out.println("Pushing    " + cities[i].getName());
					stack.push(cities[i]);
					cities[i].setVisited(true);
				}
			} else {
				stack.pop();
			}
			
			showStack();
		}
		
		if (stack.isEmpty()) {
			System.out.println("No route exists between " + source.getName() + " and " + destination.getName());
		} else {
			System.out.println("A route exists between " + source.getName() + " and " + destination.getName());
		}
	}
	
	
}
